/*
** Module   : SaxWriterImpl
** Abstract : SAX writer specific features implementation.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- ---------------------------------Description----------------------------------
** 001 EVL 20130208 Created initial version. Implementation is limited to the stubs to get the
**                  converted java code compiled.
** 002 CA  20130221 This resource doesn't have NAME attribute support.
** 003 EVL 20130320 Spelling fixes for comments.
*/

package com.goldencode.p2j.xml;

import com.goldencode.p2j.util.*;

/**
 * Implementation SAX-Writer specific features of the SAX objects.
 */
public class SaxWriterImpl
extends SaxEntityImpl
implements SaxWriter
{
   /**
    * Gets the value of the encoding attribute for the given SAX-Writer object.
    * 
    * @return   The character value of the encoding attribute.
    */
   public character getEncoding()
   {
      // TODO:
      return new character();
   }
   
   /**
    * Sets the new value of the encoding attribute for the given SAX-Writer object.
    * 
    * @param    encoding
    *           The encoding value to be set for the given writer.
    */
   public void setEncoding(String encoding)
   {
      setEncoding(new character(encoding));
   }
   
   /**
    * Sets the new value of the encoding attribute for the given SAX-Writer object.
    * 
    * @param    encoding
    *           The encoding value to be set for the given writer.
    */
   public void setEncoding(character encoding)
   {
      // TODO:
      return;
   }
   
   /**
    * Gets the value of the formatted attribute for the given SAX-Writer object. Formatted means
    * extra space or carrage returns should be added to preserve the hierarchical view of the
    * document.
    * 
    * @return   The <code>true</code> in case of formatted <code>false</code> otherwise.
    */
   public logical getFormatted()
   {
      // TODO:
      return new logical(true);
   }
   
   /**
    * Sets the value of the formatted attribute for the given SAX-Writer object. Formatted means
    * extra space or carrage returns should be added to preserve the hierarchical view of the
    * document.
    * 
    * @param    isFormatted
    *           The <code>true</code> in case of formatted <code>false</code> otherwise.
    */
   public void setFormatted(logical isFormatted)
   {
      // TODO:
      return;
   }

   /**
    * Sets the value of the formatted attribute for the given SAX-Writer object. Formatted means
    * extra space or carrage returns should be added to preserve the hierarchical view of the
    * document.
    * 
    * @param    isFormatted
    *           The <code>true</code> in case of formatted <code>false</code> otherwise.
    */
   public void setFormatted(boolean isFormatted)
   {
      // TODO:
      return;
   }

   /**
    * Gets the value of the strict attribute for the given SAX-Writer object. Strict means
    * SAX-Writer should make well formed XML document. The default is true.
    * 
    * @return   The <code>true</code> in case of strict <code>false</code> otherwise.
    */
   public logical getStrict()
   {
      // TODO:
      return new logical(true);
   }
   
   /**
    * Sets the value of the strict attribute for the given SAX-Writer object. Strict means
    * SAX-Writer should make well formed XML document. The default is true.
    * 
    * @param    isStrict
    *           The <code>true</code> in case of strict <code>false</code> otherwise.
    */
   public void setStrict(logical isStrict)
   {
      // TODO:
      return;
   }

   /**
    * Sets the value of the strict attribute for the given SAX-Writer object. Strict means
    * SAX-Writer should make well formed XML document. The default is true.
    * 
    * @param    isStrict
    *           The <code>true</code> in case of strict <code>false</code> otherwise.
    */
   public void setStrict(boolean isStrict)
   {
      setStrict(new logical(isStrict));
   }

   /**
    * Gets the value of the fragment attribute for the given SAX-Writer object. Fragment means
    * SAX-Writer output is part of the document or full.
    * 
    * @return   The <code>true</code> in case of fragment <code>false</code> for full document.
    */
   public logical getFragment()
   {
      // TODO:
      return new logical(true);
   }
   
   /**
    * Sets the value of the fragment attribute for the given SAX-Writer object. Fragment means
    * SAX-Writer output is part of the document or full.
    * 
    * @param    isFragment
    *           The <code>true</code> in case of fragment <code>false</code> for full document.
    */
   public void setFragment(logical isFragment)
   {
      // TODO:
      return;
   }
   
   /**
    * Sets the value of the fragment attribute for the given SAX-Writer object. Fragment means
    * SAX-Writer output is part of the document or full.
    * 
    * @param    isFragment
    *           The <code>true</code> in case of fragment <code>false</code> for full document.
    */
   public void setFragment(boolean isFragment)
   {
      setFragment(new logical(isFragment));
   }
   
   /**
    * Gets the value of the standalone attribute for the given SAX-Writer object.
    * 
    * @return   The character value of the standalone attribute.
    */
   public logical getStandalone()
   {
      // TODO:
      return new logical(true);
   }
   
   /**
    * Sets the value of the standalone attribute for the given SAX-Writer object.
    * 
    * @param    isStandalone
    *           The <code>true</code> in case of standalone <code>false</code> otherwise.
    */
   public void setStandalone(logical isStandalone)
   {
      // TODO:
      return;
   }
   
   /**
    * Sets the value of the standalone attribute for the given SAX-Writer object.
    * 
    * @param    isStandalone
    *           The <code>true</code> in case of standalone <code>false</code> otherwise.
    */
   public void setStandalone(boolean isStandalone)
   {
      setStandalone(new logical(isStandalone));
   }
   
   /**
    * Gets the value of the version attribute for the given SAX-Writer object.
    * 
    * @return   The character value of the version attribute.
    */
   public character getVersion()
   {
      // TODO:
      return new character();
   }
   
   /**
    * Sets the new value of the version attribute for the given SAX-Writer object.
    * 
    * @param    version
    *           The version value to be set for the given writer.
    */
   public void setVersion(String version)
   {
      setVersion(new character(version));
   }
   
   /**
    * Sets the new value of the version attribute for the given SAX-Writer object.
    * 
    * @param    version
    *           The version value to be set for the given writer.
    */
   public void setVersion(character version)
   {
      // TODO:
      return;
   }
   
   /**
    * Gets the value of the write-status attribute for the given SAX-Writer object. This is one
    * of the SAX_WRITE_* constants defined by the {@link SaxWriter} interface.
    * <p>
    * Documentation states that the type of this attribute is character, but this is incorrect. 
    * The attribute's real type is integer, same as PARSE-STATUS for the SAX-Reader object.
    * 
    * @return   The integer value of the write-status attribute.
    */
   public integer getWriteStatus()
   {
      // TODO:
      return new integer();
   }
   
   /**
    * Adds namespace declaration to a tag in a XML document associated with SAX-Writer object.
    * 
    * @param    uri
    *           The URI namespace to add.
    * @param    prefix
    *           The prefix of the namespace to add.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical declareNamespace(Text uri, Text prefix)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Adds namespace declaration to a tag in a XML document associated with SAX-Writer object.
    * 
    * @param    uri
    *           The URI namespace to add.
    * @param    prefix
    *           The prefix of the namespace to add.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical declareNamespace(String uri, Text prefix)
   {
      return endElement(new character(uri), prefix);
   }

   /**
    * Adds namespace declaration to a tag in a XML document associated with SAX-Writer object.
    * 
    * @param    uri
    *           The URI namespace to add.
    * @param    prefix
    *           The prefix of the namespace to add.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical declareNamespace(Text uri, String prefix)
   {
      return endElement(uri, new character(prefix));
   }

   /**
    * Adds namespace declaration to a tag in a XML document associated with SAX-Writer object.
    * 
    * @param    uri
    *           The URI namespace to add.
    * @param    prefix
    *           The prefix of the namespace to add.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical declareNamespace(String uri, String prefix)
   {
      return endElement(new character(uri), new character(prefix));
   }

   /**
    * Adds namespace declaration to a tag in a XML document associated with SAX-Writer object.
    * 
    * @param    uri
    *           The URI namespace to add.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical declareNamespace(String uri)
   {
      return endElement(new character(uri), new character());
   }
   
   /**
    * Adds namespace declaration to a tag in a XML document associated with SAX-Writer object.
    * 
    * @param    uri
    *           The URI namespace to add.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical declareNamespace(Text uri)
   {
      return endElement(uri, new character());
   }
   
   /**
    * Closes the XML document associated with SAX-Writer object.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical endDocument()
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Ends an XML node of the given name in a XML document associated with SAX-Writer object.
    * 
    * @param    name
    *           The name of the node to end.
    * @param    uri
    *           The URI namespace of the node to end.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical endElement(Text name, Text uri)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Ends an XML node of the given name in a XML document associated with SAX-Writer object.
    * 
    * @param    name
    *           The name of the node to end.
    * @param    uri
    *           The URI namespace of the node to end.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical endElement(String name, Text uri)
   {
      return endElement(new character(name), uri);
   }

   /**
    * Ends an XML node of the given name in a XML document associated with SAX-Writer object.
    * 
    * @param    name
    *           The name of the node to end.
    * @param    uri
    *           The URI namespace of the node to end.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical endElement(Text name, String uri)
   {
      return endElement(name, new character(uri));
   }

   /**
    * Ends an XML node of the given name in a XML document associated with SAX-Writer object.
    * 
    * @param    name
    *           The name of the node to end.
    * @param    uri
    *           The URI namespace of the node to end.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical endElement(String name, String uri)
   {
      return endElement(new character(name), new character(uri));
   }

   /**
    * Ends an XML node of the given name in a XML document associated with SAX-Writer object.
    * 
    * @param    name
    *           The name of the node to end.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical endElement(String name)
   {
      return endElement(new character(name), new character());
   }
   
   /**
    * Ends an XML node of the given name in a XML document associated with SAX-Writer object.
    * 
    * @param    name
    *           The name of the node to end.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical endElement(Text name)
   {
      return endElement(name, new character());
   }
   
   /**
    * Specifies the output destination of the XML document to be created by a SAX-Writer object.
    * 
    * @param    mode
    *           The type of the destination to write to. Can be 'FILE', 'STREAM', 'MEMPTR', 
    *           'STREAM-HANDLE' or 'LONGCHAR'.
    * @param    destination
    *           The appropriate object to write.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical setOutputDestination(String mode, Object destination)
   {
      return setOutputDestination(new character(mode), destination);
   }

   /**
    * Specifies the output destination of the XML document to be created by a SAX-Writer object.
    * 
    * @param    mode
    *           The type of the destination to write to. Can be 'FILE', 'STREAM', 'MEMPTR', 
    *           'STREAM-HANDLE' or 'LONGCHAR'.
    * @param    destination
    *           The appropriate object to write.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical setOutputDestination(character mode, Object destination)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Creates the XML document with the prolog information.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical startDocument()
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Starts the XML node according to the specified name, namespace URI and handle of the SAX
    * attribute object.
    * 
    * @param    name
    *           The name of the element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical startElement(Text name)
   {
      return startElement(name, new character(), null);
   }

   /**
    * Starts the XML node according to the specified name, namespace URI and handle of the SAX
    * attribute object.
    * 
    * @param    name
    *           The name of the element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical startElement(String name)
   {
      return startElement(new character(name), new character(), null);
   }

   /**
    * Starts the XML node according to the specified name, namespace URI and handle of the SAX
    * attribute object.
    * 
    * @param    name
    *           The name of the element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical startElement(Text name, handle handle)
   {
      return startElement(name, new character(), handle);
   }

   /**
    * Starts the XML node according to the specified name, namespace URI and handle of the SAX
    * attribute object.
    * 
    * @param    name
    *           The name of the element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical startElement(String name, handle handle)
   {
      return startElement(new character(name), new character(), handle);
   }

   /**
    * Starts the XML node according to the specified name, namespace URI and handle of the SAX
    * attribute object.
    * 
    * @param    name
    *           The name of the element.
    * @param    uri
    *           The namespace URI of the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical startElement(Text name, Text uri)
   {
      return startElement(new character(name), uri, null);
   }

   /**
    * Starts the XML node according to the specified name, namespace URI and handle of the SAX
    * attribute object.
    * 
    * @param    name
    *           The name of the element.
    * @param    uri
    *           The namespace URI of the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical startElement(String name, Text uri)
   {
      return startElement(new character(name), uri, null);
   }

   /**
    * Starts the XML node according to the specified name, namespace URI and handle of the SAX
    * attribute object.
    * 
    * @param    name
    *           The name of the element.
    * @param    uri
    *           The namespace URI of the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical startElement(Text name, String uri)
   {
      return startElement(name, new character(uri), null);
   }

   /**
    * Starts the XML node according to the specified name, namespace URI and handle of the SAX
    * attribute object.
    * 
    * @param    name
    *           The name of the element.
    * @param    uri
    *           The namespace URI of the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical startElement(String name, String uri)
   {
      return startElement(new character(name), new character(uri), null);
   }

   /**
    * Starts the XML node according to the specified name, namespace URI and handle of the SAX
    * attribute object.
    * 
    * @param    name
    *           The name of the element.
    * @param    uri
    *           The namespace URI of the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical startElement(String name, Text uri, handle handle)
   {
      return startElement(new character(name), uri, handle);
   }

   /**
    * Starts the XML node according to the specified name, namespace URI and handle of the SAX
    * attribute object.
    * 
    * @param    name
    *           The name of the element.
    * @param    uri
    *           The namespace URI of the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical startElement(Text name, String uri, handle handle)
   {
      return startElement(name, new character(uri), handle);
   }

   /**
    * Starts the XML node according to the specified name, namespace URI and handle of the SAX
    * attribute object.
    * 
    * @param    name
    *           The name of the element.
    * @param    uri
    *           The namespace URI of the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical startElement(String name, String uri, handle handle)
   {
      return startElement(new character(name), new character(uri), handle);
   }

   /**
    * Starts the XML node according to the specified name, namespace URI and handle of the SAX
    * attribute object.
    * 
    * @param    name
    *           The name of the element.
    * @param    uri
    *           The namespace URI of the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical startElement(Text name, Text uri, handle handle)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Adds CDATA block to the XML document crating by SAX-Writer object.
    * 
    * @param    cdataBlock
    *           The data to be written with CDATA block.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeCdata(String cdataBlock)
   {
      return writeCdata(new character(cdataBlock));
   }

   /**
    * Adds CDATA block to the XML document crating by SAX-Writer object.
    * 
    * @param    cdataBlock
    *           The data to be written with CDATA block.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeCdata(Text cdataBlock)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Adds character data to the XML document crating by SAX-Writer object.
    * 
    * @param    chardata
    *           The character or longchar data to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeCharacters(String chardata)
   {
      return writeCharacters(new character(chardata));
   }

   /**
    * Adds character data to the XML document crating by SAX-Writer object.
    * 
    * @param    chardata
    *           The character or longchar data to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeCharacters(Text chardata)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(Text name, Text chardata)
   {
      return writeDataElement(name, chardata, new character(), null);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(String name, Text chardata)
   {
      return writeDataElement(new character(name), chardata, new character(), null);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(Text name, String chardata)
   {
      return writeDataElement(name, new character(chardata), new character(), null);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(String name, String chardata)
   {
      return writeDataElement(new character(name), new character(chardata), new character(),
                              null);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(Text name, Text chardata, Text uri)
   {
      return writeDataElement(name, chardata, uri, null);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(String name, Text chardata, Text uri)
   {
      return writeDataElement(new character(name), chardata, uri, null);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(Text name, String chardata, Text uri)
   {
      return writeDataElement(name, new character(chardata), uri, null);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(String name, String chardata, Text uri)
   {
      return writeDataElement(new character(name), new character(chardata), uri, null);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(Text name, Text chardata, String uri)
   {
      return writeDataElement(name, chardata, new character(uri), null);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(String name, Text chardata, String uri)
   {
      return writeDataElement(new character(name), chardata, new character(uri), null);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(Text name, String chardata, String uri)
   {
      return writeDataElement(name, new character(chardata), new character(uri), null);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(String name, String chardata, String uri)
   {
      return writeDataElement(new character(name), new character(chardata),
                              new character(uri), null);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(Text name, Text chardata, handle handle)
   {
      return writeDataElement(name, chardata, new character(), handle);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(String name, Text chardata, handle handle)
   {
      return writeDataElement(new character(name), chardata, new character(), handle);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(Text name, String chardata, handle handle)
   {
      return writeDataElement(name, new character(chardata), new character(), handle);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(String name, String chardata, handle handle)
   {
      return writeDataElement(new character(name), new character(chardata), new character(),
                              handle);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(String name, Text chardata, Text uri, handle handle)
   {
      return writeDataElement(new character(name), chardata, uri, handle);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(Text name, String chardata, Text uri, handle handle)
   {
      return writeDataElement(name, new character(chardata), uri, handle);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(Text name, Text chardata, String uri, handle handle)
   {
      return writeDataElement(name, chardata, new character(uri), handle);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(String name, String chardata, Text uri, handle handle)
   {
      return writeDataElement(new character(name), new character(chardata), uri, handle);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(String name, Text chardata, String uri, handle handle)
   {
      return writeDataElement(new character(name), chardata, new character(uri), handle);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(Text name, String chardata, String uri, handle handle)
   {
      return writeDataElement(name, new character(chardata), new character(uri), handle);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(String name, String chardata, String uri, handle handle)
   {
      return writeDataElement(new character(name), new character(chardata),
                              new character(uri), handle);
   }

   /**
    * Creates complete XML node with a given SAX-Writer object.
    * 
    * @param    name
    *           The name of the element.
    * @param    chardata
    *           The XML text to write for the given element.
    * @param    uri
    *           The namespace URI of the given element.
    * @param    handle
    *           The handle of the SAX-Attribute object to be added into XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeDataElement(Text name, Text chardata, Text uri, handle handle)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Adds character data to the XML document crating by SAX-Writer object.
    * 
    * @param    chardata
    *           The character or longchar data to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeFragment(String chardata)
   {
      return writeFragment(new character(chardata));
   }

   /**
    * Adds character data to the XML document crating by SAX-Writer object.
    * 
    * @param    chardata
    *           The character or longchar data to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeFragment(Text chardata)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Adds character data to the XML document crating by SAX-Writer object.
    * 
    * @param    xhandle
    *           The valid X-Nodereference handle containing XML text.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeFragment(handle xhandle)
   {
      // TODO:
      return new logical(true);
   }
   
   /**
    * Closes the open stream and resets the SAX-Writer object to the default state.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical reset()
   {
      return new logical(true);
   }

   /**
    * Adds comment to the XML document crating by SAX-Writer object.
    * 
    * @param    comment
    *           The character or longchar text comment to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeComment(String comment)
   {
      return writeComment(new character(comment));
   }

   /**
    * Adds comment to the XML document crating by SAX-Writer object.
    * 
    * @param    comment
    *           The character or longchar text comment to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeComment(Text comment)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Creates an empty node in a given SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar element name to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEmptyElement(Text name)
   {
      return writeEmptyElement(name, new character(), null);
   }

   /**
    * Creates an empty node in a given SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar element name to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEmptyElement(String name)
   {
      return writeEmptyElement(new character(name), new character(), null);
   }

   /**
    * Creates an empty node in a given SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar element name to be written.
    * @param    uri
    *           The character or longchar element URI to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEmptyElement(Text name, Text uri)
   {
      return writeEmptyElement(name, uri, null);
   }

   /**
    * Creates an empty node in a given SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar element name to be written.
    * @param    uri
    *           The character or longchar element URI to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEmptyElement(String name, Text uri)
   {
      return writeEmptyElement(new character(name), uri, null);
   }

   /**
    * Creates an empty node in a given SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar element name to be written.
    * @param    uri
    *           The character or longchar element URI to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEmptyElement(Text name, String uri)
   {
      return writeEmptyElement(name, new character(uri), null);
   }

   /**
    * Creates an empty node in a given SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar element name to be written.
    * @param    uri
    *           The character or longchar element URI to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEmptyElement(String name, String uri)
   {
      return writeEmptyElement(new character(name), new character(uri), null);
   }

   /**
    * Creates an empty node in a given SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar element name to be written.
    * @param    attr
    *           The handle of the SAX-Attributes object to be used.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEmptyElement(Text name, handle attr)
   {
      return writeEmptyElement(name, new character(), attr);
   }

   /**
    * Creates an empty node in a given SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar element name to be written.
    * @param    attr
    *           The handle of the SAX-Attributes object to be used.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEmptyElement(String name, handle attr)
   {
      return writeEmptyElement(new character(name), new character(), attr);
   }

   /**
    * Creates an empty node in a given SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar element name to be written.
    * @param    uri
    *           The character or longchar element URI to be written.
    * @param    attr
    *           The handle of the SAX-Attributes object to be used.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEmptyElement(String name, Text uri, handle attr)
   {
      return writeEmptyElement(new character(name), uri, attr);
   }

   /**
    * Creates an empty node in a given SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar element name to be written.
    * @param    uri
    *           The character or longchar element URI to be written.
    * @param    attr
    *           The handle of the SAX-Attributes object to be used.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEmptyElement(Text name, String uri, handle attr)
   {
      return writeEmptyElement(name, new character(uri), attr);
   }

   /**
    * Creates an empty node in a given SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar element name to be written.
    * @param    uri
    *           The character or longchar element URI to be written.
    * @param    attr
    *           The handle of the SAX-Attributes object to be used.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEmptyElement(String name, String uri, handle attr)
   {
      return writeEmptyElement(new character(name), new character(uri), attr);
   }

   /**
    * Creates an empty node in a given SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar element name to be written.
    * @param    uri
    *           The character or longchar element URI to be written.
    * @param    attr
    *           The handle of the SAX-Attributes object to be used.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEmptyElement(Text name, Text uri, handle attr)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Adds an entity referenc to the XML document associated with given SAX-Writer object.
    * 
    * @param    value
    *           The character or longchar value to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEntityRef(String value)
   {
      return writeEntityRef(new character(value));
   }

   /**
    * Adds an entity referenc to the XML document associated with given SAX-Writer object.
    * 
    * @param    value
    *           The character or longchar value to be written.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeEntityRef(Text value)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Adds an external DTD reference to the XML document associated with a SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar name of the document root node.
    * @param    systemId
    *           The character or longchar system ID of the DTD.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeExternalDtd(Text name, Text systemId)
   {
      return writeExternalDtd(name, systemId, new character());
   }

   /**
    * Adds an external DTD reference to the XML document associated with a SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar name of the document root node.
    * @param    systemId
    *           The character or longchar system ID of the DTD.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeExternalDtd(String name, Text systemId)
   {
      return writeExternalDtd(new character(name), systemId, new character());
   }

   /**
    * Adds an external DTD reference to the XML document associated with a SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar name of the document root node.
    * @param    systemId
    *           The character or longchar system ID of the DTD.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeExternalDtd(Text name, String systemId)
   {
      return writeExternalDtd(name, new character(systemId), new character());
   }

   /**
    * Adds an external DTD reference to the XML document associated with a SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar name of the document root node.
    * @param    systemId
    *           The character or longchar system ID of the DTD.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeExternalDtd(String name, String systemId)
   {
      return writeExternalDtd(new character(name), new character(systemId), new character());
   }

   /**
    * Adds an external DTD reference to the XML document associated with a SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar name of the document root node.
    * @param    systemId
    *           The character or longchar system ID of the DTD.
    * @param    publicId
    *           The character or longchar public ID of the DTD.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeExternalDtd(String name, Text systemId, Text publicId)
   {
      return writeExternalDtd(new character(name), systemId, publicId);
   }

   /**
    * Adds an external DTD reference to the XML document associated with a SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar name of the document root node.
    * @param    systemId
    *           The character or longchar system ID of the DTD.
    * @param    publicId
    *           The character or longchar public ID of the DTD.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeExternalDtd(Text name, String systemId, Text publicId)
   {
      return writeExternalDtd(name, new character(systemId), publicId);
   }

   /**
    * Adds an external DTD reference to the XML document associated with a SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar name of the document root node.
    * @param    systemId
    *           The character or longchar system ID of the DTD.
    * @param    publicId
    *           The character or longchar public ID of the DTD.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeExternalDtd(String name, String systemId, Text publicId)
   {
      return writeExternalDtd(new character(name), new character(systemId), publicId);
   }

   /**
    * Adds an external DTD reference to the XML document associated with a SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar name of the document root node.
    * @param    systemId
    *           The character or longchar system ID of the DTD.
    * @param    publicId
    *           The character or longchar public ID of the DTD.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeExternalDtd(Text name, Text systemId, String publicId)
   {
      return writeExternalDtd(name, systemId, new character(publicId));
   }

   /**
    * Adds an external DTD reference to the XML document associated with a SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar name of the document root node.
    * @param    systemId
    *           The character or longchar system ID of the DTD.
    * @param    publicId
    *           The character or longchar public ID of the DTD.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeExternalDtd(String name, Text systemId, String publicId)
   {
      return writeExternalDtd(new character(name), systemId, new character(publicId));
   }

   /**
    * Adds an external DTD reference to the XML document associated with a SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar name of the document root node.
    * @param    systemId
    *           The character or longchar system ID of the DTD.
    * @param    publicId
    *           The character or longchar public ID of the DTD.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeExternalDtd(Text name, String systemId, String publicId)
   {
      return writeExternalDtd(name, new character(systemId), new character(publicId));
   }

   /**
    * Adds an external DTD reference to the XML document associated with a SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar name of the document root node.
    * @param    systemId
    *           The character or longchar system ID of the DTD.
    * @param    publicId
    *           The character or longchar public ID of the DTD.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeExternalDtd(String name, String systemId, String publicId)
   {
      return writeExternalDtd(new character(name), new character(systemId),
                              new character(publicId));
   }

   /**
    * Adds an external DTD reference to the XML document associated with a SAX-Writer object.
    * 
    * @param    name
    *           The character or longchar name of the document root node.
    * @param    systemId
    *           The character or longchar system ID of the DTD.
    * @param    publicId
    *           The character or longchar public ID of the DTD.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeExternalDtd(Text name, Text systemId, Text publicId)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Creates a processing instruction node in XML document for given SAX-Writer object.
    * 
    * @param    target
    *           The character or longchar target of the processing instruction.
    * @param    data
    *           The character or longchar data associated with the processing instruction.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeProcessingInstruction(String target, Text data)
   {
      return writeProcessingInstruction(new character(target), data);
   }

   /**
    * Creates a processing instruction node in XML document for given SAX-Writer object.
    * 
    * @param    target
    *           The character or longchar target of the processing instruction.
    * @param    data
    *           The character or longchar data associated with the processing instruction.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeProcessingInstruction(Text target, String data)
   {
      return writeProcessingInstruction(target, new character(data));
   }

   /**
    * Creates a processing instruction node in XML document for given SAX-Writer object.
    * 
    * @param    target
    *           The character or longchar target of the processing instruction.
    * @param    data
    *           The character or longchar data associated with the processing instruction.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeProcessingInstruction(String target, String data)
   {
      return writeProcessingInstruction(new character(target), new character(data));
   }

   /**
    * Creates a processing instruction node in XML document for given SAX-Writer object.
    * 
    * @param    target
    *           The character or longchar target of the processing instruction.
    * @param    data
    *           The character or longchar data associated with the processing instruction.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical writeProcessingInstruction(Text target, Text data)
   {
      // TODO:
      return new logical(true);
   }
   
   /**
    * Check if this resource supports the NAME attribute.
    * 
    * @return   Always <code>false</code>.
    */
   @Override
   protected boolean hasName()
   {
      return false;
   }
}
